function b = loadobj(a)
% loadobj routine pour la classe @IsaacIMG (appel par load)
% nb : error() n'interrompt pas load
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

objversion = 2;

%---------------------------------------------------------------------------------------------------

if isa(a,'IsaacIMG')
	if (a.version == objversion)
		b = a;
		return
	end	
	if (a.version > objversion)
		IsaacMessageErreur('nouvelle version d''@IsaacIMG non gre par cette version d''Isaac')
		b = struct(a);
		return
	end
	% a.version < objversion
	a = struct(a);
else
	% a converti en structure par load
	if ~isfield(a,'version')
		IsaacMessageErreur('version d''@IsaacIMG inconnue')
		b = a;
		return
	end
	if (a.version > objversion)
		IsaacMessageErreur('nouvelle version d''@IsaacIMG non gre par cette version d''Isaac')
		b = a;
		return
	end
	if (a.version == objversion)
		IsaacMessageErreur('erreur imprvue  la lecture de l''objet @IsaacIMG')
		b = a;
		return
	end
	% a.version < objversion
end

% maj structure a
switch a.version
	case 1
		% ajout de la donne de gestion converted
		a.converted = true;
		% suppression de la donne de gestion eventinfo
		a = rmfield(a,'eventinfo');
	case 2
		%
		% maj des champs de l'objet a
		%
	otherwise
		IsaacMessageErreur('ancienne version d''@IsaacIMG non gre')
		b = a;
		return
end
a.version = objversion;
IsaacMessageWarning('ancienne version d''@IsaacIMG convertie')

% dclaration de l'objet b
b = class(orderfields(a),'IsaacIMG'); % orderfields car class est sensible  l'ordre
