function ImageVue_upd(fighnd,event,eventobj,auteur)															%#ok
% Raction ImageVue aux vnements recus
%
% @<- EVENEMENTS 1/2/31/41/71/91/101/111
%
% Tool for OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% Accepte les vnements causs par (auteur = soi-mme) pour mise  jour graphique

%---------------------------------------------------------------------------------------------------

%if (auteur == fighnd) 
% 	return
%end	

global ISAACINFO

switch event
case 1
	% pas d'image cible
	set(findobj(fighnd,'Tag','StxtCibleName'),'ForegroundColor',ISAACINFO.TextColor3, ...
		'String','pas d''image cible')
	% popup string = 1 espace (et pas '') sinon le popup ne s'affiche pas
	set(findobj(fighnd,'Tag','PopupPlan1'),'Enable','off','String',' ','Value',1)
	set(findobj(fighnd,'Tag','PopupPlan2'),'Enable','off','String',' ','Value',1)
	set(findobj(fighnd,'Tag','PopupPlan3'),'Enable','off','String',' ','Value',1)
	set(findobj(fighnd,'Tag','RadMarginal'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','RadCouleur'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','ButEch-'),'Enable','off')
	set(findobj(fighnd,'Tag','ButEchR'),'Enable','off')
	set(findobj(fighnd,'Tag','ButEch+'),'Enable','off')
	set(findobj(fighnd,'Tag','StxtEchVal'),'String',' ')
	set(findobj(fighnd,'Tag','ChkZoom'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','ButZoomReset'),'Enable','off')
	set(findobj(fighnd,'Tag','ButGamma-'),'Enable','off')
	set(findobj(fighnd,'Tag','ButGammaR'),'Enable','off')
	set(findobj(fighnd,'Tag','ButGamma+'),'Enable','off')
	set(findobj(fighnd,'Tag','StxtGammaVal'),'String','')
	set(findobj(fighnd,'Tag','ChkED'),'Enable','off','Value',0)
	% popup string = 1 espace (et pas '') sinon le popup ne s'affiche pas
	set(findobj(fighnd,'Tag','PopupPal'),'Enable','off','String',' ','Value',1)
	set(findobj(fighnd,'Tag','ROIS0'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','ROISR'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','ROISC'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','ROIV0'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','ROIVR'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','ROIVC'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','ROIcomp'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','ROIcomp'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','ButCreerVisuel'),'Enable','off')
case 2
	% changement cible
	set(findobj(fighnd,'Tag','ButCreerVisuel'),'Enable','on')
	set(findobj(fighnd,'Tag','StxtCibleName'),'ForegroundColor',ISAACINFO.TextColor1, ...
		'String',IsaacImage_get(eventobj,'Name'))
	set(findobj(fighnd,'Tag','PopupPlan1'),'Enable','on')
	set(findobj(fighnd,'Tag','ChkZoom'),'Enable','on')
	UpdateVisuel
	UpdateZoomScale
	UpdateRoi
case 31
	% rinitialisation ou modif totale
	UpdateVisuel
	UpdateZoomScale
	UpdateRoi
case {41,71}
	% modif affichage roi
	UpdateRoi
case 91
	% modif params affichage ou roi
	UpdateVisuel
	UpdateRoi	
case 101
	% modif chelle ou zoom
	UpdateZoomScale
case 111
	% changement de nom cible
	set(findobj(fighnd,'Tag','StxtCibleName'),'String',IsaacImage_get(eventobj,'Name'))
end

% --- Nested fonction ------------------------------------------------------------------------------

function UpdateVisuel

parama = IsaacImage_get(eventobj,'ParamA');
paramr = IsaacImage_get(eventobj,'ParamR');
s = cell(paramr.dimz,1);
for i = 1:paramr.dimz
	s{i} = num2str(i);
end
% popup string = 1 espace (et pas '') sinon le popup ne s'affiche pas
if parama.marginal
	if (paramr.dimz < 3)
		set(findobj(fighnd,'Tag','RadMarginal'),'Enable','inactive','Value',1)
		if (paramr.dimz == 1)
			set(findobj(fighnd,'Tag','PopupPlan1'),'Enable','inactive','String',s,'Value',1)
		else
			set(findobj(fighnd,'Tag','PopupPlan1'),'Enable','on','String',s,'Value',parama.plan(1))
		end	
		set(findobj(fighnd,'Tag','RadCouleur'),'Enable','off','Value',0)
		set(findobj(fighnd,'Tag','PopupPlan2'),'Enable','off','String',' ','Value',1)
		set(findobj(fighnd,'Tag','PopupPlan3'),'Enable','off','String',' ','Value',1)
	else
		set(findobj(fighnd,'Tag','RadMarginal'),'Enable','on','Value',1)
		set(findobj(fighnd,'Tag','RadCouleur'),'Enable','on','Value',0)
		set(findobj(fighnd,'Tag','PopupPlan1'),'Enable','on','String',s,'Value',parama.plan(1))
		set(findobj(fighnd,'Tag','PopupPlan2'),'Enable','off','String',s,'Value',parama.plan(2))
		set(findobj(fighnd,'Tag','PopupPlan3'),'Enable','off','String',s,'Value',parama.plan(3))
	end		
	if (paramr.nbbits == 1)
		set(findobj(fighnd,'Tag','PopupPal'),'Enable','off','String',' ','Value',1)
	else		
		set(findobj(fighnd,'Tag','PopupPal'),'Enable','on','String', ...
			ISAACINFO.PalStr,'Value',parama.pal)
	end	
else
	set(findobj(fighnd,'Tag','RadCouleur'),'Enable','on','Value',1)
	set(findobj(fighnd,'Tag','RadMarginal'),'Enable','on','Value',0)
	set(findobj(fighnd,'Tag','PopupPlan1'),'Enable','on','String',s,'Value',parama.plan(1))
	set(findobj(fighnd,'Tag','PopupPlan2'),'Enable','on','String',s,'Value',parama.plan(2))
	set(findobj(fighnd,'Tag','PopupPlan3'),'Enable','on','String',s,'Value',parama.plan(3))
	set(findobj(fighnd,'Tag','PopupPal'),'Enable','off','String',' ','Value',1)
end
if (paramr.nbbits > 1)
	set(findobj(fighnd,'Tag','ButGamma-'),'Enable','on')
	set(findobj(fighnd,'Tag','ButGammaR'),'Enable','on')
	set(findobj(fighnd,'Tag','ButGamma+'),'Enable','on')
	set(findobj(fighnd,'Tag','StxtGammaVal'),'String',num2str(parama.gamma,'%.1f'))
	set(findobj(fighnd,'Tag','ChkED'),'Enable','on','Value',parama.ED)
else
	set(findobj(fighnd,'Tag','ButGamma-'),'Enable','off')
	set(findobj(fighnd,'Tag','ButGammaR'),'Enable','off')
	set(findobj(fighnd,'Tag','ButGamma+'),'Enable','off')
	set(findobj(fighnd,'Tag','StxtGammaVal'),'String','')
	set(findobj(fighnd,'Tag','ChkED'),'Enable','off','Value',0)
end

end % fin nested fonction

% --- Nested fonction ------------------------------------------------------------------------------

function UpdateZoomScale

echelle = IsaacImage_get(eventobj,'Echelle');
zoom = IsaacImage_get(eventobj,'Zoom');	
set(findobj(fighnd,'Tag','ChkZoom'),'Value',zoom)
if zoom
	set(findobj(fighnd,'Tag','ButZoomReset'),'Enable','on')
else
	set(findobj(fighnd,'Tag','ButZoomReset'),'Enable','off')
end	
if (echelle < 1)
	set(findobj(fighnd,'Tag','StxtEchVal'),'String',['1/',num2str(1/echelle)])
else
	set(findobj(fighnd,'Tag','StxtEchVal'),'String',[num2str(echelle),'/1'])
end	
set(findobj(fighnd,'Tag','ButEch-'),'Enable','on')
set(findobj(fighnd,'Tag','ButEchR'),'Enable','on')
set(findobj(fighnd,'Tag','ButEch+'),'Enable','on')

end % fin nested fonction

% --- Nested fonction ------------------------------------------------------------------------------

function UpdateRoi

paramaroi = IsaacImage_get(eventobj,'ParamARoi');
if IsaacImage_get(eventobj,'IsRoi')
	set(findobj(fighnd,'Tag','ROIcomp'),'Enable','on','Value',paramaroi.showRoiComp)
	if IsaacImage_get(eventobj,'IsRoiSpa')
		switch paramaroi.showRoiSpa
		case 0
			set(findobj(fighnd,'Tag','ROIS0'),'Enable','on','Value',1)
			set(findobj(fighnd,'Tag','ROISR'),'Enable','on','Value',0)
			set(findobj(fighnd,'Tag','ROISC'),'Enable','on','Value',0)
		case 1
			set(findobj(fighnd,'Tag','ROIS0'),'Enable','on','Value',0)
			set(findobj(fighnd,'Tag','ROISR'),'Enable','on','Value',1)
			set(findobj(fighnd,'Tag','ROISC'),'Enable','on','Value',0)
		case 2
			set(findobj(fighnd,'Tag','ROIS0'),'Enable','on','Value',0)
			set(findobj(fighnd,'Tag','ROISR'),'Enable','on','Value',0)
			set(findobj(fighnd,'Tag','ROISC'),'Enable','on','Value',1)
		end
	else
		set(findobj(fighnd,'Tag','ROIS0'),'Enable','on','Value',1)
		set(findobj(fighnd,'Tag','ROISR'),'Enable','off','Value',0)
		set(findobj(fighnd,'Tag','ROISC'),'Enable','off','Value',0)
	end
	if IsaacImage_get(eventobj,'IsRoiVal')
		switch paramaroi.showRoiVal
		case 0
			set(findobj(fighnd,'Tag','ROIV0'),'Enable','on','Value',1)
			set(findobj(fighnd,'Tag','ROIVR'),'Enable','on','Value',0)
			set(findobj(fighnd,'Tag','ROIVC'),'Enable','on','Value',0)
		case 1
			set(findobj(fighnd,'Tag','ROIV0'),'Enable','on','Value',0)
			set(findobj(fighnd,'Tag','ROIVR'),'Enable','on','Value',1)
			set(findobj(fighnd,'Tag','ROIVC'),'Enable','on','Value',0)
		case 2
			set(findobj(fighnd,'Tag','ROIV0'),'Enable','on','Value',0)
			set(findobj(fighnd,'Tag','ROIVR'),'Enable','on','Value',0)
			set(findobj(fighnd,'Tag','ROIVC'),'Enable','on','Value',1)
		end
	else
		set(findobj(fighnd,'Tag','ROIV0'),'Enable','on','Value',1)
		set(findobj(fighnd,'Tag','ROIVR'),'Enable','off','Value',0)
		set(findobj(fighnd,'Tag','ROIVC'),'Enable','off','Value',0)
	end
else
	set(findobj(fighnd,'Tag','ROIcomp'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','ROIS0'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','ROISR'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','ROISC'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','ROIV0'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','ROIVR'),'Enable','off','Value',0)
	set(findobj(fighnd,'Tag','ROIVC'),'Enable','off','Value',0)
end	

end % fin nested fonction

%---------------------------------------------------------------------------------------------------

end % fin ImageVue_upd en raison des nested fonctions
