function IsaacModBox_cb(choix)
% Callback IsaacModBox
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% N'utilise pas la rception d'vnements causs par (auteur = soi-mme) pour mise  jour graphique

%---------------------------------------------------------------------------------------------------

global ISAACPRIV
global ISAACPREF

switch(choix)
case 'RadButListe_E'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 vient d'tre mis  1
		set(findobj(gcbf,'Tag','RadButListe_S'),'Value',0)
		ud = get(gcbf,'UserData');
		ud.PIndex = [1,get(findobj(gcbf,'Tag','ListParam_E'),'Value')];
		param = ud.Param{ud.PIndex(1)}(ud.PIndex(2));
		if param.opidx
			ud.PTarget = param.options(param.opidx);
		else
			ud.PTarget = 0;
		end
		set(gcbf,'UserData',ud)
		% affichage options param
		IsaacModBox_majopt(gcbf,0);
	else % tait  1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end
case 'ListParam_E'
	if ~get(findobj(gcbf,'Tag','RadButListe_E'),'Value')
		set(findobj(gcbf,'Tag','RadButListe_E'),'Value',1)
		set(findobj(gcbf,'Tag','RadButListe_S'),'Value',0)
	end
	ud = get(gcbf,'UserData');
	ud.PIndex = [1,get(gcbo,'Value')];
	param = ud.Param{ud.PIndex(1)}(ud.PIndex(2));
	if param.opidx
		ud.PTarget = param.options(param.opidx);
	else
		ud.PTarget = 0;
	end
	set(gcbf,'UserData',ud)
	% affichage options param
	IsaacModBox_majopt(gcbf,0);
case 'RadButListe_S'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 vient d'tre mis  1
		set(findobj(gcbf,'Tag','RadButListe_E'),'Value',0)
		ud = get(gcbf,'UserData');
		ud.PIndex = [2,get(findobj(gcbf,'Tag','ListParam_S'),'Value')];
		param = ud.Param{ud.PIndex(1)}(ud.PIndex(2));
		if param.opidx
			ud.PTarget = param.options(param.opidx);
		else
			ud.PTarget = 0;
		end
		set(gcbf,'UserData',ud)
		% affichage options param
		IsaacModBox_majopt(gcbf,0);
	else % tait  1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end
case 'ListParam_S'
	if ~get(findobj(gcbf,'Tag','RadButListe_S'),'Value')
		set(findobj(gcbf,'Tag','RadButListe_S'),'Value',1)
		set(findobj(gcbf,'Tag','RadButListe_E'),'Value',0)
	end	
	ud = get(gcbf,'UserData');
	ud.PIndex = [2,get(gcbo,'Value')];
	param = ud.Param{ud.PIndex(1)}(ud.PIndex(2));
	if param.opidx
		ud.PTarget = param.options(param.opidx);
	else
		ud.PTarget = 0;
	end
	set(gcbf,'UserData',ud)
	% affichage options param
	IsaacModBox_majopt(gcbf,0);
case 'RadButParamWS'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		set(findobj(gcbf,'Tag','RadButParamCible'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		ud.PTarget = 1;
		set(gcbf,'UserData',ud)
		% maj option slectionne
		IsaacModBox_majopt(gcbf,1);
	else % tait  1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButParamCible'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		set(findobj(gcbf,'Tag','RadButParamWS'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		ud.PTarget = 2;
		set(gcbf,'UserData',ud)
		% maj option slectionne
		IsaacModBox_majopt(gcbf,2);
	else % tait  1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButParamMem'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		set(findobj(gcbf,'Tag','RadButParamWS'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamCible'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		ud.PTarget = 3;
		set(gcbf,'UserData',ud)
		% maj option slectionne
		IsaacModBox_majopt(gcbf,3);
	else % tait  1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButParamFich'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		set(findobj(gcbf,'Tag','RadButParamWS'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamCible'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		ud.PTarget = 4;
		set(gcbf,'UserData',ud)
		% maj option slectionne
		IsaacModBox_majopt(gcbf,4);
	else % tait  1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButParamMATLAB'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		set(findobj(gcbf,'Tag','RadButParamWS'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamCible'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		ud.PTarget = 5;
		set(gcbf,'UserData',ud)
		% maj option slectionne
		IsaacModBox_majopt(gcbf,5);
	else % tait  1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end
case 'EtxtWSVarname'
	ud = get(gcbf,'UserData');
	ud.WSVarName = get(gcbo,'String');
	set(gcbf,'UserData',ud);
case 'EtxtVarname'
	ud = get(gcbf,'UserData');
	ud.PVarName = get(gcbo,'String');
	set(gcbf,'UserData',ud);
case 'ButParamValider'
	% remplissage des valeurs de ud.Param pour le paramtre slectionn
	ud = get(gcbf,'UserData');
	param = ud.Param{ud.PIndex(1)}(ud.PIndex(2));
	switch ud.PTarget
	case 1
		% base workspace (objet @IsaacDATA uniquement)
		if (ud.PIndex(1) == 1) 
			% entre = objet @IsaacDATA initialis avec val = variable
			try
				param.nom = ['variable importe (' ud.WSVarName ')'];
				param.val = IsaacDATA([],param.nom);
				param.val = IsaacDATA_import(param.val,ud.WSVarName);
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACPREF.TextColor1, ...
					'String',['variable ',ud.WSVarName, ' de type ', ...
					IsaacDATA_get(param.val,'Class'),' importe'])
         catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACPREF.TextColor3, ...
					'String','chec import variable')
				return
			end
		else
			% sortie = nom de la variable
			param.val = ud.WSVarName;
			param.nom = ['variable exporte (' ud.WSVarName ')'];
		end
	case 2
		% image cible
		% entre = handle de la figure de l'image cible 
		% (pas de IsaacImage_get car l'image peut tre modifie avant l'appui sur executer)
		% sortie = handle de la figure de l'image cible 
		param.val = ISAACPRIV.Cible;
		param.nom = IsaacImage_get(ISAACPRIV.Cible,'Name');		
	case 3
		% mmoire
		if (ud.PIndex(1) == 1) 
			% entre = objet lu en mmoire
			param.val = IsaacParamPull(param.label);
			if isempty(param.val)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACPREF.TextColor3, ...
					'String','mmoire vide')
				return
			end
			set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACPREF.TextColor1, ...
				'String','mmoire lue')
			if strcmp(param.label,'DATA')
				param.nom = [param.label ' type ' IsaacDATA_get(param.val,'Type')];
			else
				param.nom = param.label;
			end	
		else
			% sortie = rien
			param.val = []; 
			param.nom = param.label;
		end
	case 4
		% fichier
		if (ud.PIndex(1) == 1) 
			% entre = objet lu dans le fichier
			[filename,dirname] = IsaacUIgetfile('Ouvrir un fichier :');
			if filename == 0
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
				return
			end
			try
				switch param.label
				case 'IMG'
                    param.val = IsaacIMG(fullfile(dirname,filename));
                case 'ROI'
                    param.val = IsaacROI(fullfile(dirname,filename));
                case 'ECOL'
                    param.val = IsaacECOL(fullfile(dirname,filename));
                case 'HISTO'
                    param.val = IsaacHISTO(fullfile(dirname,filename));
                case 'LPIX'
                    param.val = IsaacLPIX(fullfile(dirname,filename));
                case 'DATA'
                    param.val = IsaacDATA(fullfile(dirname,filename));
				end
				IsaacCD(dirname)
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACPREF.TextColor3, ...
					'String','chec lecture fichier')
				return
			end
			set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACPREF.TextColor1, ...
					'String',['fichier ',filename,' lu'])
			param.nom = filename;
		else
			% sortie = nom de rpertoire pour criture du fichier
			dirname = IsaacUIgetdir('Slectionner un dossier :');
			if dirname == 0
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
				return
			end
			try
				param.val = dirname;
				param.nom = IsaacPathStr(dirname,1);
				parentdir = fileparts(dirname);
				IsaacCD(parentdir)
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACPREF.TextColor3, ...
					'String','chec slection dossier')
				return
			end
		end
	case 5
		% MATLAB
		if (ud.PIndex(1) == 1) 
			% entre = variable objet
			try
				param.val = IsaacParamImport(param.label,ud.PVarName);
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACPREF.TextColor1, ...
					'String',['objet ',ud.PVarName, ' de type ',param.label,' import'])
				param.nom = ud.PVarName;
			catch exception
				IsaacMessageErreur(IsaacError(exception))	
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACPREF.TextColor3, ...
					'String','chec import MATLAB')
				return
			end	
		else
			% sortie = nom de la variable objet
			param.val = ud.PVarName;
			param.nom = ud.PVarName;
		end
	end
	param.opidx = find(param.options == ud.PTarget);
	param.ok = true;
	switch param.options(param.opidx)
	case 1
		% workspace variable
		s = 'V';
	case 2
		% image cible
		s = 'I';
	case 3
		% mmoire
		s = 'M';	
	case 4
		% fichier
		s = 'F';
	case 5
		% MATLAB objet
		s = 'O';
	end	
	param.affi = sprintf('%-5s : %s : %s',param.label,s,param.nom);
	ud.Param{ud.PIndex(1)}(ud.PIndex(2)) = param;
	clear param
	if (ud.PIndex(1) == 1)
		set(findobj(gcbf,'Tag','ListParam_E'),'String',{ud.Param{1}.affi})
	else
		set(findobj(gcbf,'Tag','ListParam_S'),'String',{ud.Param{2}.affi})
	end
	n = 0;
	if ud.ParamNb(1)
		n = sum([ud.Param{1}.ok]);
	end
	if ud.ParamNb(2)
		n = n + sum([ud.Param{2}.ok]);
	end
	if (n == sum(ud.ParamNb))
		set(findobj(gcbf,'Tag','ButDo'),'Enable','on')
	end
	set(gcbf,'UserData',ud)
% Gnral ------------------------------------------------------------------------------------------	
case 'ButParamInfo'
	ud = get(gcbf,'UserData');
	savedir = pwd;
	cd(ud.ModDirName)
	ud.InfoHnd = IsaacDialogInfo(help(ud.ModName));
	cd(savedir)
	set(gcbf,'UserData',ud)
case 'ButDo'	
	set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
	ud = get(gcbf,'UserData');
	% lecture des donnes (@IsaacIMG | @IsaacROI | @IsaacECOL) en entre si opval == image ouverte
	% (seule la handle de l'image cible avait t mmorise dans param.val)
	for i = 1:ud.ParamNb(1)
		opval = ud.Param{1}(i).options(ud.Param{1}(i).opidx);
		if (opval == 2)
			ud.Param{1}(i).val = IsaacImage_get(ud.Param{1}(i).val,ud.Param{1}(i).label);
		end
	end	
	try
		% appel du module
		if (ud.ParamNb(2) == 0)
			if (ud.ParamNb(1) == 0)
				IsaacModule(ud.ModName)
			else
				IsaacModule(ud.ModName,ud.Param{1}(:).val)
			end	
		else
			pval = cell(1,ud.ParamNb(2));
			if (ud.ParamNb(1) == 0)
				[pval{:}] = IsaacModule(ud.ModName);
			else				
				[pval{:}] = IsaacModule(ud.ModName,ud.Param{1}(:).val);
			end	
		end
		% traitement des paramtres de sortie
		for i = 1:ud.ParamNb(2)
			param = ud.Param{2}(i);
			if isempty(pval{i})
				IsaacMessageWarning(['paramtre de sortie ',param.label,' vide']) 
			else
				switch param.options(param.opidx)
				case 1
					% workspace variable (objet @IsaacDATA uniquement)
					IsaacDATA_export(pval{i},param.val)
					% Mode Bavard 
					IsaacMessageBavard(['export de ',param.label,' dans la variable ',param.val])
				case 2
					% Image ouverte (pas forcment la cible)
					index = FindImage(param.val);
					if isempty(index) 
						% l'image a t ferme aprs verif ButDo (improbable !!!)
						error('image destination inaccessible')
					end
					ObjImage = ISAACPRIV.TabIsaacImage(index);
					switch param.label
					case {'ROI','ECOL'}
						IsaacImage_set(ObjImage,gcbf,param.label,pval{i});
					case 'IMG'	
						ObjImageName = IsaacImage_get(ObjImage,'Name');
						if IsaacImage_get(ObjImage,'IsRoiSpa')
							s = {ObjImageName; ...
								'Prendre en compte la ROI spatiale de destination ?'};
							UseSpaMask = strcmp(IsaacDialogQuestion(s,true),'Oui');
						else
							UseSpaMask = false;
						end	
						if UseSpaMask
							IsaacImage_set(ObjImage,gcbf,'IMG', ...
								IsaacIMG_fillmask(IsaacImage_get(ObjImage,'IMG'),pval{i}, ...
									IsaacImage_get(ObjImage,'RSMask')));
						else
							% renommage de l'image comme sa destination
							pval{i} = IsaacIMG_set(pval{i},'ImgName',ObjImageName);
							IsaacImage_set(ObjImage,gcbf,'IMG',pval{i});
						end
					end	
				case 3
					% Mmoire
					IsaacParamPush(pval{i})
					% Mode Bavard 
					IsaacMessageBavard(['mmorisation de ',param.label])
				case 4
					% Fichier
					dirname = param.val;
					s = [param.label,'_',datestr(clock,'yymmddHHMMSS')];
					switch param.label
					case 'IMG'
						filename = IsaacImgFileName(s);
						IsaacIMG_saveas(pval{i},fullfile(dirname,filename));
					case 'ROI'
						filename = IsaacFileName([s,'.mat']);
						IsaacROI_saveas(pval{i},fullfile(dirname,filename));
					case 'ECOL'
						filename = IsaacFileName([s,'.mat']);
						IsaacECOL_saveas(pval{i},fullfile(dirname,filename));
					case 'HISTO'
						filename = IsaacFileName([s,'.mat']);
						IsaacHISTO_saveas(pval{i},fullfile(dirname,filename));
					case 'LPIX'
						filename = IsaacFileName([s,'.mat']);
						IsaacLPIX_saveas(pval{i},fullfile(dirname,filename));
					case 'DATA'
						filename = IsaacFileName([s,'.mat']);
						IsaacDATA_saveas(pval{i},fullfile(dirname,filename));
					end
					IsaacPause(1) % pour numrotation avec au moins une seconde d'cart
					% Mode Bavard 
					IsaacMessageBavard('criture de',fullfile(dirname,filename))	
				case 5
					% MATLAB
					IsaacParamExport(pval{i},param.val)
					% Mode Bavard 
					IsaacMessageBavard(['export de ',param.label,' dans la variable ',param.val])
				end
			end	
		end
	catch exception
		IsaacMessageErreur(IsaacError(exception))
	end
case 'CloseBox'
	if ~ISAACPRIV.IsEnd
		ud = get(gcbf,'UserData');
		if ishandle(ud.InfoHnd)
			close(ud.InfoHnd)
		end
		IsaacEventUpdListe(gcbf,[])
	end	
	closereq
end

% --- Nested fonction ------------------------------------------------------------------------------

function index = FindImage(obj)
% Retourne l'index dans ISAACPRIV.TabIsaacImage de l'image mmorise ou []

for index = 1:ISAACPRIV.NbOpenImg
	if (ISAACPRIV.TabIsaacImage(index) == obj)
		return
	end
end
index = [];

end % fin nested fonction

%---------------------------------------------------------------------------------------------------

end % fin RoiEdit_cb en raison des nested fonctions
